/*
  Main code by Richard Visokey AD7C - <a href="http://www.ad7c.com" title="www.ad7c.com" rel="nofollow">www.ad7c.com</a>
  Revision 2.0 - November 6th, 2013
*/

//  --  Modified 05.11.2015 --

// Include the library code
#include <LiquidCrystal.h>
#include <Rotary.h>
#include <EEPROM.h>
#include "si5351.h"
#include "Wire.h"
 

// Установка энкодера
#define ENCODER_A    3                      // Encoder pin A
#define ENCODER_B    2                      // Encoder pin B
Rotary r = Rotary(ENCODER_A, ENCODER_B);
Si5351 si5351;

// Установка дисплея
LiquidCrystal lcd(4, 5, 6, 7, 8, 9); // I used an odd pin combination because I need pin 2 and 3 for the interrupts.

// Рабочие переменные
volatile uint32_t vfo2 = 1; // variable to hold the updated frequency
volatile uint32_t increment = 1000; // starting VFO update increment in KHz.
int buttonstate_10 = 0;
int buttonstate_11 = 0;
int STEP = 5;
String hertz = "               ";
byte ones, tens, hundreds, thousands, tenthousands, hundredthousands, millions; //Placeholders
byte A = 0;
byte B = 0;
volatile uint32_t timepassed = millis(); // int to hold the arduino miilis since startup
int memstatus = 1;  // value to notify if memory is current or old. 0=old, 1=current.
 int evendivisor = 100;
int ForceFreq = 0;  // "1" - Задать начальную частоту 10000 кГц, "0" - Режим хранения последней частоты

byte Start_Reset_Flg_EEPROM10  = 0;
// Переменные для идентификации вращения энкодера
unsigned long time_old = 0;
unsigned long time_new = 0;
unsigned long delta_time = 0;
unsigned long abs_delta_time = 0;
unsigned long long pll_freq = 88000000000ULL;
volatile uint32_t FREQ_Si5351 = 0ULL;
 unsigned long long vfo = 710000000ULL * 100;

unsigned long Correct_EEPROM20  =  185000; //  185000

int case_MENU = 0;
int in_Key;                     // код нажатой кнопки
int Flg_Key_MENU=0; 
int Key_FLOCK=0;
int fl_FLOCK=0;
int Flg_STEP_10 = 0;
int Flg_STEP_11 = 0;

int  in_in_KeyA = 0;     // А временная переменная для анализа данных с кнопки
long lo_in_KeyB = 0;     // В временная переменная для анализа данных с кнопки
//=======================================================================
void setup() {

  Serial.begin(9600);
  lcd.begin(16, 2);       // настройуа LC
  lcd.clear();
  Wire.begin();
  
// Порты, пины для управл.  
 pinMode(10,INPUT);  //  для кнопки STEP -
 pinMode(11,INPUT);  //  для кнопки STEP+
 pinMode(12,INPUT);  // для кнопки MENU
 pinMode(13,INPUT);  //  для кнопки F.LOCK / BAND
 
  digitalWrite(10, HIGH);
  digitalWrite(11, HIGH);
  digitalWrite(12, HIGH);
  digitalWrite(13, HIGH);

  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();

  // --------  Start screen    --------
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("VFO Phase Si5351");
  lcd.setCursor(0, 1);
  lcd.print("3.2MHz....120MHz");
  delay(2000);
  lcd.setCursor(0, 1);

 // delay(600);
  // Бегущая строка - экран приветствия
  for (int positionCounter = 0; positionCounter < 16; positionCounter++) {
    lcd.scrollDisplayLeft();
    delay(50);
  }

  //  Очистим экран после приветствия
  lcd.clear();

 if ( EEPROM.get(10, Start_Reset_Flg_EEPROM10) != 221 || digitalRead(12)== LOW )
 {
    EEPROM.put(20, Correct_EEPROM20);
    EEPROM.put(10, 221);
    EEPROM.put(0, vfo);
    EEPROM.put(30, STEP);
  }
  // Загружаем из EEPROM сохраненную там частоту
  if (ForceFreq == 0) { EEPROM.get(0, vfo);}
  
  STEP = EEPROM.get(30, STEP);

  // Задаем начальный режим
  // hertz = "  100KHz";
  //  lcd.setCursor(0,1); lcd.print(STEP);
  lcd.setCursor(3, 1); lcd.print("Step:");
  lcd.setCursor(8, 1); lcd.print(hertz);

  // Запоминаем опорное время
  time_old = millis();
  abs_delta_time = 100; // Фиксируем шаг 100Гц
  // Установка на выходе CLK0 начальную частоту 10 MHz

  Correct_EEPROM20 = EEPROM.get(20, Correct_EEPROM20);
  //  si5351.set_correction( 100); // 204000
  si5351.output_enable(SI5351_CLK0, 1);
  si5351.output_enable(SI5351_CLK1, 1);
  si5351.output_enable(SI5351_CLK2, 0);

   si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);
   si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_2MA); //you can set this to 2MA, 4MA, 6MA or 8MA
  si5351.drive_strength(SI5351_CLK1, SI5351_DRIVE_2MA); //you can set this to 2MA, 4MA, 6MA or 8MA

si5351.set_freq_manual(vfo * SI5351_FREQ_MULT, evendivisor * vfo * SI5351_FREQ_MULT, SI5351_CLK0);

si5351.set_freq_manual(vfo * SI5351_FREQ_MULT, evendivisor * vfo * SI5351_FREQ_MULT, SI5351_CLK1);
      
si5351.set_phase(SI5351_CLK0, 0);
si5351.set_phase(SI5351_CLK1, evendivisor);
si5351.pll_reset(SI5351_PLLA);
si5351.update_status();

}  // Конец инициализации void setup()


// ************  Главный цикл **********
void loop() {

  KEYBOARD();
  if ( case_MENU == 0) { showFreq();LCD_Step();}

  // Если частота изменилась в последнем цикле, то
  if (vfo != vfo2 ){OUT_Si5351() ;vfo2 = vfo;}

  // Пишем частоту в EEPROM, если не записана, и прошли 1,5 секунды со времени последнего изменения частоты.
  if (memstatus == 0)
  {
    if (millis() >= timepassed + 1500)  {
      storeMEM();
      abs_delta_time = 1000;
    }
  }
         //   Serial.println(STEP);
      //   Serial.println(increment);
}
// Закончили главный цикл
// ************  Конец цикла **********


// Ловушка прерывания при вращении энкодера
ISR(PCINT2_vect) {
  unsigned char result = r.process();

  if (result) // Если начали вращать энкодер
  {
    // Определяем скорость вращения

    time_new = millis(); // Запоминаем время импульса
    delta_time = (time_new - time_old); // Вычисляем интервал времени между импульсами
    abs_delta_time = abs(delta_time); // Абс. величина интервала
    time_old = time_new; // Перезапоминаем опорное время

    // В зависимости от направления вращения "+" или "-" инкремент
    if (result == DIR_CW)
    { if (case_MENU == 0 and fl_FLOCK == 0) {
        vfo = vfo + increment;
        vfo = ( vfo / increment) * increment;
        // Ограничение макс. частоты
            if (vfo > 120000000) { vfo = vfo2; }; 
        storeMEM();
      }
      if (case_MENU == 1 ) {
        EEPROM.put(20, Correct_EEPROM20 = EEPROM.get(20, Correct_EEPROM20) + increment);
      }
    }
    else
    { if (case_MENU == 0 and fl_FLOCK == 0 ) {
        vfo = vfo - increment;
        vfo = ( vfo / increment) * increment;
         // Ограничение мин. частоты
             if (vfo <= 3200000) {
     // vfo = vfo2;
     vfo = 3200000; };
        storeMEM();
      }
      if (case_MENU == 1 ) {
        EEPROM.put(20, Correct_EEPROM20 = EEPROM.get(20, Correct_EEPROM20) - increment);
        if (Correct_EEPROM20 <= 0) {
          Correct_EEPROM20 = 0;
          EEPROM.put(20, Correct_EEPROM20);
        }
      }
    }
    Correct_EEPROM20 = EEPROM.get(20, Correct_EEPROM20);

  } // Конец обработки вращения энкодера
}  //  Конец ловушки прерывания


// Индикация частоты
void showFreq()
{
  if (case_MENU == 0 ) {
    millions = int(vfo / 1000000);
    hundredthousands = ((vfo / 100000) % 10);
    tenthousands = ((vfo / 10000) % 10);
    thousands = ((vfo / 1000) % 10);
    hundreds = ((vfo / 100) % 10);
    tens = ((vfo / 10) % 10);
    ones = ((vfo / 1) % 10);
    lcd.setCursor(0, 0);

    lcd.print(' ');
    if (millions > 9) {
      lcd.setCursor(1, 0);
    }
    else {
      lcd.setCursor(1, 0);
    }
    lcd.print(millions);
    lcd.print(".");
    lcd.print(hundredthousands);
    lcd.print(tenthousands);
    lcd.print(thousands);
    lcd.print(".");
    lcd.print(hundreds);
    lcd.print(tens);
    lcd.print(ones);
    lcd.print(" MHz");
    lcd.print(' ');
    lcd.print(' ');
    timepassed = millis();
    memstatus = 0; // Trigger memory write
  }
};

// Запись частоты в EEPROM
void storeMEM() {
  //Write each frequency section to a EPROM slot.  Yes, it's cheating but it works!
  EEPROM.put(0, vfo);
  memstatus = 1;  // Let program know memory has been written
};

void OUT_Si5351() {
  if (vfo > 120000000) {
    vfo = vfo2;
  }; // Ограничение макс. частоты
  if (vfo < 3000000) {
    vfo = vfo2;
  };   // Ограничение мин. частоты
  //  si5351.set_clock_invert(SI5351_CLK0, 1); 
   // si5351.set_clock_invert(SI5351_CLK1, 1); 
if (vfo >= 1000000   and vfo <= 4920000) {evendivisor = 142; }//????????????? надо проверять evendivisor

if (vfo >> 4920000   and vfo <= 7200000) {evendivisor = 122; }
if (vfo >> 7200000   and vfo <= 10400000) {evendivisor = 84; }
if (vfo >> 10400000  and vfo <= 15080000) {evendivisor = 58; } 
if (vfo >> 15080000  and vfo <= 21700000) {evendivisor = 40; } 
if (vfo >> 21700000  and vfo <= 30500000) {evendivisor = 28; } 
if (vfo >> 30500000  and vfo <= 43000000) {evendivisor = 20; }
if (vfo >> 43000000  and vfo <= 61000000) {evendivisor = 14; }
if (vfo >> 61000000  and vfo <= 82000000) {evendivisor = 10; }
if (vfo >> 82000000  and vfo <= 105000000){evendivisor = 8;} 
if (vfo >> 105000000 and vfo <= 146660000){evendivisor = 6;}
if (vfo >> 146660000 and vfo <= 220000000){evendivisor = 4;} 
 
si5351.set_freq_manual(vfo * SI5351_FREQ_MULT, evendivisor * vfo * SI5351_FREQ_MULT, SI5351_CLK0);
si5351.set_freq_manual(vfo * SI5351_FREQ_MULT, evendivisor * vfo * SI5351_FREQ_MULT, SI5351_CLK1);
      
si5351.set_phase(SI5351_CLK0, 0);
si5351.set_phase(SI5351_CLK1, evendivisor);
si5351.pll_reset(SI5351_PLLA);
si5351.update_status();

}

void KEYBOARD() {
  //************* подпрограмма измерения состояния кнопок ===============

    //  нажата КНОПКА STEP + 
  buttonstate_11 = digitalRead(11);
  if (buttonstate_11 == LOW and  Flg_STEP_11 == 0 and fl_FLOCK == 0) // Если нажата
  {
    //Организуем счетчик нажатий кнопки
     STEP = EEPROM.get(30, STEP);
     
     if (STEP >> 0) {STEP = STEP - 1;}
     if (STEP == 0) {STEP = 0; }

     Flg_STEP_11 = 1;
  }
 
    //  нажата КНОПКА STEP - 
  buttonstate_10 = digitalRead(10);
  if (buttonstate_10 == LOW and  Flg_STEP_10 == 0 and fl_FLOCK == 0) // Если нажата
  {
     STEP = EEPROM.get(30, STEP);
    //Организуем счетчик нажатий кнопки
     STEP = STEP + 1;
     if (STEP >= 7) {
       STEP = 7;
   }
     Flg_STEP_10 = 1;
  }
 //  нажата КНОПКА MENU
   if (buttonstate_10 == HIGH and  Flg_STEP_10 == 1) {Flg_STEP_10 = 0; EEPROM.put(30, STEP); LCD_Step();}
   if (buttonstate_11 == HIGH and  Flg_STEP_11 == 1) {Flg_STEP_11 = 0; EEPROM.put(30, STEP); LCD_Step();}
   
   if (fl_FLOCK == 0 and Flg_Key_MENU == 0){
   if (digitalRead(12)== HIGH ){ if(A>> 0){A=0;}}
   if (digitalRead(12)== LOW  ){A++; if(A>= 50){A=50;}}
   if (digitalRead(12)== LOW   and A == 50)
      { 
      case_MENU++ ;  //  по шаговое изменение SETUP меню
    if (case_MENU >= 2 ) { case_MENU = 0; A=0; lcd.setCursor(0, 1); lcd.print("                "); } 
    Flg_Key_MENU = 1; 
     }
   }

   if(digitalRead(12)== HIGH and Flg_Key_MENU == 1) {Flg_Key_MENU = 0 ;}
    {
      LCD_MENU();     
  }
 //  нажата КНОПКА F.LOCK  and Key_FLOCK == 0
  if (case_MENU == 0){
   if (digitalRead(13)== HIGH and fl_FLOCK == 1){ B = 0; Key_FLOCK = 1;}
   if (digitalRead(13)== HIGH and fl_FLOCK == 0){ B = 0; Key_FLOCK = 0;}
   if (digitalRead(13)== LOW and Key_FLOCK == 0){ B++; if( B >= 50){ B = 50; fl_FLOCK = 1; }}
   if (digitalRead(13)== LOW and Key_FLOCK == 1){ B++; if( B >= 50){ B = 50; fl_FLOCK = 0; }}
}
}

void LCD_Step() {
  if(fl_FLOCK == 0){
  // Назначаем действия по каждому состоянию счетчика нажатий
  lcd.setCursor(3, 1); lcd.print("Step:");
  switch (STEP) {
   case 0:
      {
        increment = 1000000;
        hertz = "   1 MHz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 1:
      {
        increment = 100000;
        hertz = " 100 KHz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 2:
      {
        increment = 10000;
        hertz = "  10 KHz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 3:
      {
        increment = 1000;
        hertz = "   1 KHz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 4:
      {
        increment = 100;
        hertz = "  100 Hz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 5:
      {
        increment = 50;
        hertz = "   50 Hz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 6:
      {
        increment = 10;
        hertz = "   10 Hz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    case 7:
      {
        increment = 1;
        hertz = "   1  Hz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
      break;
    default:
      {
        increment = 1000;
        hertz = "   1 KHz";
        lcd.setCursor(8, 1);
        lcd.print(hertz);
      }
  }
}
 Serial.print(" fl_FLOCK  "); Serial.println(digitalRead(fl_FLOCK));
 if(fl_FLOCK == 1){ lcd.setCursor(0, 1); lcd.print("     F.LOCK     ");}
}

void  LCD_MENU()
{
      if(case_MENU == 1)//первый режим 
        {   
    lcd.setCursor(0, 0);
    lcd.print("1Corr.PLL=");
    lcd.print(Correct_EEPROM20);
    lcd.print("  ");
     lcd.setCursor(3, 1); lcd.print("Step:");lcd.print(increment);lcd.print("      "); lcd.print(' ');
        } 
        
    if(case_MENU==2)//второй режим 
       { 
     lcd.setCursor(0, 0);
    lcd.print("2Corr.PLL=");
    lcd.print(Correct_EEPROM20);
    lcd.print("  ");
     lcd.setCursor(3, 1); lcd.print("Step:");lcd.print(increment);lcd.print("      "); lcd.print(' ');
        } 
             
    if(case_MENU==3)//третий режим 
         {  
     lcd.setCursor(0, 0);
    lcd.print("3Corr.PLL=");
    lcd.print(Correct_EEPROM20);
    lcd.print("  ");
     lcd.setCursor(3, 1); lcd.print("Step:");lcd.print(increment);lcd.print("      "); lcd.print(' ');
    }  
       
    if(case_MENU==4)//четвертый режим 
         { 
     lcd.setCursor(0, 0);
    lcd.print("4Corr.PLL=");
    lcd.print(Correct_EEPROM20);
    lcd.print("  ");
     lcd.setCursor(3, 1); lcd.print("Step:");lcd.print(increment);lcd.print("      "); lcd.print(' ');
    } 
  } 
